/***************************************************************************
 *            insertion_sort.c
 *
 *  Thu Nov 29 22:39:27 2007
 *  Copyright  2007  pchero21
 *  pchero21@gmail.com
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct Node {		// type of strcut Node
    char name[50];
     int number;
} node;

/******************************************************************************/
/*											 Functions 																			*/

// sorting nodes by insertion sort algorithm.
void insertion_sort(int n, node *array);

// swap the each nodes.
void swap_node(node *a, node *b);

// make random array.
void make_RanArray(int max, node *array);

/******************************************************************************/


int main()
{
	int array_size;					// number of index
	node *array;					// index array
	int i;								// tmp number

	printf("Insert array index numbers\n");
	printf("Insert : ");
	scanf("%d", &array_size);

	array = (node *)malloc(array_size * sizeof(node));
	
	make_RanArray(array_size, array);

	printf("\n\nBefore insertion_sort\n");
	printf("Name : ");
	for(i = 0; i < array_size; i++)
		printf("%s ", array[i].name);
	putchar('\n');
	printf("Number : ");
	for(i = 0; i < array_size; i++)
		printf("%d ", array[i].number);
	putchar('\n');
	
	insertion_sort(array_size, array);
	
	printf("\n\nAfter insertion_sort\n");
	printf("Name : ");
	for(i = 0; i < array_size; i++)
		printf("%s ", array[i].name);
	putchar('\n');
	printf("Number : ");
	for(i = 0; i < array_size; i++)
		printf("%d ", array[i].number);
	putchar('\n');
	
	
	return 0;
}


void insertion_sort(int n, node *array)
{
	int i, j;
	node x;

	for(i = 1; i < n; i++) {
		strcpy(x.name, array[i].name);
		x.number = array[i].number;	
		j = i - 1;

		while(j >= 0 && strcmp(array[j].name, x.name) > 0) {
			swap_node(&array[j + 1], &array[j]);
			j--;
		}
		swap_node(&array[j + 1], &x);
	}
}

void swap_node(node *a, node *b)
{
	node tmp;

	strcpy(tmp.name, b->name);
	tmp.number = b->number;

	strcpy(b->name, a->name);
	b->number = a->number;

	strcpy(a->name, tmp.name);
	a->number = tmp.number;
}

void make_RanArray(int max, node *array)
{
	int i, tmp_number;
	char char_tmp;

	char_tmp = 'a';

	for(i = 0; i < max; i++) {
		array[i].number = i;
		if(i != 0)
			strcpy(array[i].name, array[i - 1].name);
		array[i].name[i] = char_tmp + i;
		array[i].name[i + 1] = '\0';
	}
	tmp_number = max;
	for(i = 0; i < tmp_number; i++)
		swap_node(&array[rand() % (max - 1)], &array[--tmp_number]);
		
	for(i = 0; i < max; i++)
		array[i].number = i;
}
